#include <windows.h>
#include <stdio.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include <AR/ar.h>
#include <AR/param.h>
#include <AR/video.h>
#include <AR/gsub.h>

#include "controller.h"	// L[{[hɂ鐧
#include "GLMetaseq.h"	// f[_


// Cu̐ݒ
#ifdef _DEBUG
	#pragma comment(lib,"libARd.lib")
	#pragma comment(lib,"libARgsubd.lib")
	#pragma comment(lib,"libARvideod.lib")
	#pragma comment(linker,"/NODEFAULTLIB:libcmtd.lib")
#else
	#pragma comment(lib,"libAR.lib")
	#pragma comment(lib,"libARgsub.lib")
	#pragma comment(lib,"libARvideo.lib")
	#pragma comment(linker,"/NODEFAULTLIB:libcmt.lib")
#endif


// LN^f[^\
typedef struct {
	MQO_MODEL	model;
	GLfloat		rot;
	GLfloat		x;
	GLfloat		y;
	GLfloat		z;
} CHARACTER_DATA;


// O[oϐ
static char	*g_vconf_name	= "Data/WDM_camera_flipV.xml";	// rfIfoCX̐ݒt@C
static char	*g_cparam_name  = "Data/camera_para.dat";		// Jp[^t@C
static char	*g_patt_name    = "Data/patt.tachikoma";		// p^[t@C
static char	*g_mqo_name		= "Data/tachikoma.mqo";			// MQOt@C

static int		g_patt_id;							// p^[ID
static double	g_patt_trans[3][4];					// Wϊs
static double	g_patt_center[2]	= { 0.0, 0.0 };	// p^[̒SW
static double	g_patt_width		= 80.0;			// p^[̃TCYiPʁFmmj
static int		g_thresh			= 100;			// 2l臒l

static CHARACTER_DATA	g_tachikoma = { NULL, 0.0, 0.0, 0.0, 0.0 };	// LN^̃f[^
static int				g_light_on  = TRUE;							// VF[fBOOn/Off
static int				g_optcmf_on = FALSE;						// wʂOn/Off


// vg^Cv錾
static void MainLoop(void);
static void Cleanup(void);
static void DrawObject( ARUint8 *image );
static void CalcState(void);
static void SetLight( GLenum light );
static void OpticalCamouflage( unsigned char *image );
static void GetObjectDepth( GLfloat *depth, int width, int height, GLfloat *depth_min, GLfloat *depth_max );
static void DrawImage( unsigned char *color_buf, int width, int height );



// ===========================================================================
// main֐
// ===========================================================================
int main( int argc, char **argv )
{
	ARParam	cparam;			// Jp[^
	ARParam	wparam;			// Jp[^iƗpϐj
	int		xsize, ysize;	// 摜TCY

	// GLUT̏
	glutInit( &argc, argv );

	// rfIfoCX̐ݒ
	if ( arVideoOpen( g_vconf_name ) < 0 ) {
		printf("rfIfoCX̃G[");
		return -1;
	}

	// Jp[^̐ݒ
	if ( arVideoInqSize( &xsize, &ysize ) < 0 ) {
		printf("摜TCY擾ł܂ł\n");
		return -1;
	}
	if ( arParamLoad( g_cparam_name, 1, &wparam ) < 0 ) {
		printf("Jp[^̓ǂݍ݂Ɏs܂\n");
		return -1;
	}
	arParamChangeSize( &wparam, xsize, ysize, &cparam );
	arInitCparam( &cparam );

	// p^[t@C̃[h
	if ( (g_patt_id = arLoadPatt(g_patt_name)) < 0 ) {
		printf("p^[t@C̓ǂݍ݂Ɏs܂\n");
		return -1;
	}

	// EBhE̐ݒ
	argInit( &cparam, 1.0, 0, 0, 0, 0 );
	glutSetWindowTitle("^`R} on ARToolKit");

	// GLMetaseq̏
	mqoInit();

	// f̓ǂݍ
	if ( ( g_tachikoma.model = mqoCreateModel( g_mqo_name, 1.0 )) == NULL ) {
		printf("f̓ǂݍ݂Ɏs܂\n");
		return -1;
	}

	// rfILv`̊Jn
	arVideoCapStart();

	// IɌĂԊ֐w
	atexit( Cleanup );

	// L[{[h֐̓o^
	glutKeyboardUpFunc( KeyUp );
	glutSpecialFunc( SpecialKeyDown );
	glutSpecialUpFunc( SpecialKeyUp );

	printf("<<@>>\n");
	printf("L[ : ړ\n");
	printf("   %c     : ʒuɃZbg\n", KEY_B);
	printf("   %c     : VF[fBOOn/Off\n", KEY_A);
	printf("   %c     : wOn/Off \n", KEY_C);
	printf("  ESC    : I\n");

	// C[v̊Jn
	argMainLoop( NULL, KeyDown, MainLoop );

	return 0;
}


// ===========================================================================
// C[v֐
// ===========================================================================
static void MainLoop(void)
{
	ARUint8			*image;
	ARMarkerInfo	*marker_info;
	int				marker_num;
	int				j, k;

	// J摜̎擾
	if ( (image = arVideoGetImage()) == NULL ) {
		arUtilSleep( 2 );
		return;
	}

	// J摜̕`
	argDrawMode2D();
	argDispImage( image, 0, 0 );

	// }[J̌oƔF
	if ( arDetectMarker( image, g_thresh, &marker_info, &marker_num ) < 0 ) {
		exit(0);
	}

	// ̉摜̃Lv`w
	arVideoCapNext();

	// }[J̐Mx̔r
	k = -1;
	for( j = 0; j < marker_num; j++ ) {
		if ( g_patt_id == marker_info[j].id ) {
			if ( k == -1 ) k = j;
			else if ( marker_info[k].cf < marker_info[j].cf ) k = j;
		}
	}

	if ( k != -1 ) {
		// }[J̈ʒuEpiWϊsǰvZ
		arGetTransMat( &marker_info[k], g_patt_center, g_patt_width, g_patt_trans );

		// 3DIuWFNg̕`
		DrawObject( image );
	}

	// obt@̓eʂɕ\
	argSwapBuffers();
}


// ===========================================================================
// I֐
// ===========================================================================
static void Cleanup(void)
{
    arVideoCapStop();	// rfILv`̒~
    arVideoClose();		// rfIfoCX̏I
    argCleanup();		// OtBbN̏I

	mqoDeleteModel( g_tachikoma.model );	// f̍폜
	mqoCleanup();							// GLMetaseq̏I
}


// ===========================================================================
// 3DIuWFNg̕`s֐
// ===========================================================================
static void DrawObject( ARUint8 *image )
{
	double	gl_para[16];

	// IuWFNg̏ԂvZ
	CalcState();

	// 3DIuWFNg`悷邽߂̏
	argDrawMode3D();
	argDraw3dCamera( 0, 0 );

	// ̐ݒ
	glPushMatrix();
		SetLight(GL_LIGHT0);
	glPopMatrix();

	// Wϊs̓Kp
	argConvGlpara( g_patt_trans, gl_para );
	glMatrixMode( GL_MODELVIEW );
	glLoadMatrixd( gl_para );

	// 3DIuWFNg̕`
	glClear( GL_DEPTH_BUFFER_BIT );		// Zobt@̏
	glEnable( GL_DEPTH_TEST );			// Bʏ̓Kp

	// VF[fBO
	if ( g_light_on ) {
		glEnable( GL_LIGHTING );	// CgOn
	} else {
		glDisable( GL_LIGHTING );	// CgOff
	}

	// f̕`
	glPushMatrix();
		glTranslatef( g_tachikoma.x, g_tachikoma.y, g_tachikoma.z ) ;	// f̈ʒu
		glRotatef( g_tachikoma.rot, 0.0, 0.0, 1.0);						// f̌
		glRotatef( 90.0, 1.0, 0.0, 0.0 );								// f𗧂
		mqoCallModel( g_tachikoma.model );								// f̕`
	glPopMatrix();

	glDisable( GL_LIGHTING );
	glDisable( GL_DEPTH_TEST );

	// w
	if ( g_optcmf_on ) {
		OpticalCamouflage( image );
	}
}


// ===========================================================================
// IuWFNg̏ԂvZ֐
// ===========================================================================
static void CalcState(void)
{
	CONTROLLER_DATA	control;	// Rg[iL[{[hj
	static GLfloat v = 0;		// is̑x

	// Rg[̃f[^擾
	GetControllerData( &control );

	// ƌ
	if ( control.up == KEY_DOWN ) {
		// ɉ
		v = 20;
	} else if ( control.down  == KEY_DOWN ) { 
		// tɉ
		v = -20;
	} else {
		// 
		if (v>0) { v--; }
		else if (v<0) { v++; }
	}

	// ]
	if ( control.right == KEY_DOWN ) { g_tachikoma.rot -= 20.0; }
	if ( control.left  == KEY_DOWN ) { g_tachikoma.rot += 20.0; }

	// ړ
	g_tachikoma.x +=  v * sin(g_tachikoma.rot*3.14/180);
	g_tachikoma.y += -v * cos(g_tachikoma.rot*3.14/180);


	// VF[fBOOn/Off
	if ( control.A == KEY_DOWN ) g_light_on = !g_light_on;

	// ʒuɃZbg
	if ( control.B == KEY_DOWN ) {
		g_tachikoma.rot = 0;
		g_tachikoma.x = 0;
		g_tachikoma.y = 0;
		g_tachikoma.z = 0;
	}

	// wʂOn/Off
	if ( control.C == KEY_DOWN ) g_optcmf_on = !g_optcmf_on;

}


// ===========================================================================
// ̐ݒs֐
// ===========================================================================
static void SetLight( GLenum light )
{
	GLfloat light_diffuse[]  = { 0.9, 0.9, 0.9, 1.0 };	// gUˌ
	GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };	// ʔˌ
	GLfloat light_ambient[]  = { 0.3, 0.3, 0.3, 0.1 };	// 
	GLfloat light_position[] = { 0.0, 0.0, 0.0, 1.0 };	// ʒuƎ

	// ̐ݒ
	glLightfv( light, GL_DIFFUSE,  light_diffuse );	 // gUˌ̐ݒ
	glLightfv( light, GL_SPECULAR, light_specular ); // ʔˌ̐ݒ
	glLightfv( light, GL_AMBIENT,  light_ambient );	 // ̐ݒ
	glLightfv( light, GL_POSITION, light_position ); // ʒuƎނ̐ݒ

	glEnable( light );	// ̗L
}


// ===========================================================================
// wʏs֐
// ===========================================================================
static void OpticalCamouflage( unsigned char *image )
{
	GLfloat			*depth_buf, *pDepth;			// fvXobt@
	unsigned char	*color_buf, *pColor;			// J[obt@
	GLfloat			depth_obj_min, depth_obj_max;	// ̂̃fvXl̍ŏlEől
	GLfloat			depth, depth_obj_n;				// fvXlÂ̐KfvXl
	unsigned char	cmfR, cmfG, cmfB;				// wʂ̐F
	int				width, height;					// 摜TCY
	int				i, x, y, dx, dy;

	// ʂ̐Fiʂ̗̈ɔF邽߂̐ݒBꂼ0`255j
	cmfR = 255;
	cmfG = 255;
	cmfB = 255;

	// 摜TCY̎擾iARToolKit̃O[oϐ擾j
	width = arImXsize;
	height = arImYsize;

	// fvXobt@̎擾
	depth_buf = (GLfloat*)malloc( width * height * sizeof(GLfloat) );
	glReadPixels( 0, 0, width, height, GL_DEPTH_COMPONENT, GL_FLOAT, depth_buf);

	// `p̃obt@쐬
	color_buf = (unsigned char*)malloc( width * height * 4 );

	if ( color_buf == NULL || depth_buf == NULL ) return;

	// IuWFNg̃fvXl̍őŏ߂
	GetObjectDepth( depth_buf, width, height, &depth_obj_min, &depth_obj_max);

	// X^XLp̃|C^̏
	pDepth = depth_buf;
	pColor = color_buf;

	for (y=0; y<height; y++) {
		for (x=0; x<width; x++) {

			// fvXl
			depth = *pDepth++;

			if ( depth < 1.0 ) {
				// IuWFNg̈̏ꍇ

				// fvXl𐳋K
				depth_obj_n = ( depth - depth_obj_min )/( depth_obj_max - depth_obj_min );

				// fvXlɓǂݎW炷ic܂j
				dx = (int)( x -0.05 * width * depth_obj_n * ((x-width/2.0)*0.01) );
				dy = (int)( y -0.05 * height * depth_obj_n * ((y-height/2.0)*0.01) );
				if ( dx < 0 ) dx = x;
				if ( dy < 0 ) dy = y;

				// CfbNX߂
				i = 4 * ( (height-1-dy) * width + dx );

				// fl̏
				*pColor++ = (unsigned char)( image[i+2] * 0.9 + cmfR * 0.1 );	// R
				*pColor++ = (unsigned char)( image[i+1] * 0.9 + cmfG * 0.1 );	// G
				*pColor++ = (unsigned char)( image[i]   * 0.9 + cmfB * 0.1 );	// B
				*pColor++ = 255;												// A

			} else {
				// wȉꍇ
				pColor += 3;
				*pColor++ = 0;
			}
		}
	}

	// 摜̕`
	DrawImage( color_buf, width ,height );

	// obt@̊J
	free( depth_buf );
	free( color_buf );
}


// ===========================================================================
// IuWFNg̃fvXl̍ŏlAől߂֐
// depth         : fvXobt@
// width, height : 摜TCY
// depth_min     : fvXl̍ŏl
// depth_max     : fvXl̍őliwi=1.0j
// ===========================================================================
static void GetObjectDepth( GLfloat *depth, int width, int height,
							GLfloat *depth_min, GLfloat *depth_max )
{
	GLfloat min = 0;
	GLfloat max = 0;
	GLfloat d;
	int i;

	for ( i=0; i<width*height; i++ ) {

		d = *depth++;

		if ( i==0 ) {
			min = d;
			max = 0;
		} else {
			if ( d > max && d <1.0 ) max = d;
			if ( d < min ) min = d;
		}
	}

	*depth_min = min;
	*depth_max = max;
}


// ===========================================================================
// 摜̕`s֐
// color_buf     : J[obt@
// width, height : 摜TCY
// ===========================================================================
void DrawImage( unsigned char *color_buf, int width, int height )
{
	// ˉesۑ
	glMatrixMode( GL_PROJECTION );
	glPushMatrix();

		// ˉesύX
		glLoadIdentity();
		gluOrtho2D( 0, width, 0, height );

		// fr[sۑ
		glMatrixMode( GL_MODELVIEW );
		glPushMatrix();

			// 摜̕`
			glLoadIdentity();
			glRasterPos2i( 0, 0 );
			glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
			glEnable( GL_BLEND);
			glDrawPixels( width, height, GL_RGBA, GL_UNSIGNED_BYTE, color_buf );
			glDisable( GL_BLEND );

		// fr[s𕜌
		glPopMatrix();

	// ˉes𕜌
	glMatrixMode( GL_PROJECTION );
	glPopMatrix();
}
